diff --git a/qemu-io-cmds.c b/qemu-io-cmds.c
index 4184fb8..1e444cc 100644
--- a/qemu-io-cmds.c
+++ b/qemu-io-cmds.c
@@ -434,13 +434,14 @@ static int do_pread(BlockBackend *blk, char *buf, int64_t offset,
 }

 static int do_pwrite(BlockBackend *blk, char *buf, int64_t offset,
-                     int64_t count, int64_t *total)
+                     int64_t count, bool fua, int64_t *total)
 {
     if (count > INT_MAX) {
         return -ERANGE;
     }

-    *total = blk_pwrite(blk, offset, (uint8_t *)buf, count, 0);
+    *total = blk_pwrite(blk, offset, (uint8_t *)buf, count,
+                        fua ? BDRV_REQ_FUA : 0);
     if (*total < 0) {
         return *total;
     }
@@ -452,6 +453,7 @@ typedef struct {
     int64_t offset;
     int64_t count;
     int64_t *total;
+    bool fua;
     int ret;
     bool done;
 } CoWriteZeroes;
@@ -461,7 +463,8 @@ static void coroutine_fn co_write_zeroes_entry(void *opaque)
     CoWriteZeroes *data = opaque;

     data->ret = blk_co_write_zeroes(data->blk, data->offset / BDRV_SECTOR_SIZE,
-                                    data->count / BDRV_SECTOR_SIZE, 0);
+                                    data->count / BDRV_SECTOR_SIZE,
+                                    data->fua ? BDRV_REQ_FUA : 0);
     data->done = true;
     if (data->ret < 0) {
         *data->total = data->ret;
@@ -472,7 +475,7 @@ static void coroutine_fn co_write_zeroes_entry(void *opaque)
 }

 static int do_co_write_zeroes(BlockBackend *blk, int64_t offset, int64_t count,
-                              int64_t *total)
+                              bool fua, int64_t *total)
 {
     Coroutine *co;
     CoWriteZeroes data = {
@@ -480,6 +483,7 @@ static int do_co_write_zeroes(BlockBackend *blk, int64_t offset, int64_t count,
         .offset = offset,
         .count  = count,
         .total  = total,
+        .fua    = fua,
         .done   = false,
     };

@@ -950,6 +954,7 @@ static void write_help(void)
 " filled with a set pattern (0xcdcdcdcd).\n"
 " -b, -- write to the VM state rather than the virtual disk\n"
 " -c, -- write compressed data with blk_write_compressed\n"
+" -f, -- use Force Unit Access semantics\n"
 " -p, -- ignored for back-compat\n"
 " -P, -- use different pattern to fill file\n"
 " -C, -- report statistics in a machine parsable format\n"
@@ -966,7 +971,7 @@ static const cmdinfo_t write_cmd = {
     .cfunc      = write_f,
     .argmin     = 2,
     .argmax     = -1,
-    .args       = "[-bcCqz] [-P pattern ] off len",
+    .args       = "[-bcCfqz] [-P pattern ] off len",
     .oneline    = "writes a number of bytes at a specified offset",
     .help       = write_help,
 };
@@ -975,7 +980,7 @@ static int write_f(BlockBackend *blk, int argc, char **argv)
 {
     struct timeval t1, t2;
     int Cflag = 0, qflag = 0, bflag = 0, Pflag = 0, zflag = 0;
-    int cflag = 0;
+    int cflag = 0, fflag = 0;
     int c, cnt;
     char *buf = NULL;
     int64_t offset;
@@ -984,7 +989,7 @@ static int write_f(BlockBackend *blk, int argc, char **argv)
     int64_t total = 0;
     int pattern = 0xcd;

-    while ((c = getopt(argc, argv, "bcCpP:qz")) != -1) {
+    while ((c = getopt(argc, argv, "bcCfpP:qz")) != -1) {
         switch (c) {
         case 'b':
             bflag = 1;
@@ -995,6 +1000,9 @@ static int write_f(BlockBackend *blk, int argc, char **argv)
         case 'C':
             Cflag = 1;
             break;
+        case 'f':
+            fflag = 1;
+            break;
         case 'p':
             /* Ignored for back-compat */
             break;
@@ -1025,6 +1033,11 @@ static int write_f(BlockBackend *blk, int argc, char **argv)
         return 0;
     }

+    if (fflag && (bflag + cflag)) {
+        printf("-f and -b or -c cannot be specified at the same time\n");
+        return 0;
+    }
+
     if (zflag && Pflag) {
         printf("-z and -P cannot be specified at the same time\n");
         return 0;
@@ -1069,11 +1082,11 @@ static int write_f(BlockBackend *blk, int argc, char **argv)
     if (bflag) {
         cnt = do_save_vmstate(blk, buf, offset, count, &total);
     } else if (zflag) {
-        cnt = do_co_write_zeroes(blk, offset, count, &total);
+        cnt = do_co_write_zeroes(blk, offset, count, fflag, &total);
     } else if (cflag) {
         cnt = do_write_compressed(blk, buf, offset, count, &total);
     } else {
-        cnt = do_pwrite(blk, buf, offset, count, &total);
+        cnt = do_pwrite(blk, buf, offset, count, fflag, &total);
     }
     gettimeofday(&t2, NULL);